--REGISTER OUR SOUNDS WITH LIBSHAREDMEDIA-3.0--
local LSM = LibStub("LibSharedMedia-3.0")
LSM:Register("sound", "Zelda: AOL_Deflect", "Interface\\AddOns\\Plink!\\sounds\\AOL_Deflect.wav")
LSM:Register("sound", "Zelda: LOZ_Shield", "Interface\\AddOns\\Plink!\\sounds\\LOZ_Shield.wav")
LSM:Register("sound", "Zelda: LTTP_Rupee1", "Interface\\AddOns\\Plink!\\sounds\\LTTP_Rupee1.wav")
LSM:Register("sound", "Zelda: MC_Rupee", "Interface\\AddOns\\Plink!\\sounds\\MC_Rupee.wav")
LSM:Register("sound", "Zelda: MC_Rupee_Bounce", "Interface\\AddOns\\Plink!\\sounds\\MC_Rupee_Bounce.wav")
LSM:Register("sound", "Zelda: OOT_Arrow_Hit_Ice", "Interface\\AddOns\\Plink!\\sounds\\OOT_Arrow_Hit_Ice.wav")
LSM:Register("sound", "Zelda: Oracle_Secret", "Interface\\AddOns\\Plink!\\sounds\\Oracle_Secret.wav")
LSM:Register("sound", "Zelda: WW_Map_Close_Tingle", "Interface\\AddOns\\Plink!\\sounds\\WW_Map_Close_Tingle.wav")

--ARE YOU A WARRIOR?--
if select(2, UnitClass("player")) ~= "WARRIOR" then
	return
end

local reflect = 23920	--Spell Reflect buff ID
local dur = 4.9	--Spell Reflect duration
local counter = 0	--timer var
local player = UnitName("player")
local timerFrame = CreateFrame("Frame")
local chan = {"RAID", "PARTY", "Self", "None"}
local widgetLists = AceGUIWidgetLSMlists

local defaults = {
    profile = {
        channel = "Self",
		message = "Your message here!",
		sound = "Zelda: LOZ_Shield",
    },
}


-----------------------------------
--MEAT AND POTATOES--
-----------------------------------

Plink = LibStub("AceAddon-3.0"):NewAddon("Plink!", "AceConsole-3.0", "AceEvent-3.0")

--OPTIONS--
local options = {
	name = "Plink",
	handler = Plink,
	type = "group",
	args = {
		standby = {		
			name = "Standby",
			desc = "Puts the addon into standby mode, so no sounds are heard.",
			type = "toggle",
			get = function()
						return Plink.db.profile.standby
					end,
			set = function()
						Plink.db.profile.standby = not Plink.db.profile.standby
						Plink:AddMessage("Standby mode is now set to: "..Plink.db.profile.standby)
					end
		},
		config = {
			name = "Config",
			desc = "Opens the options window.",
			type = "execute",
			func = function()
					LibStub("AceConfigDialog-3.0"):Open("Plink")
				end,
			guiHidden = true,
		},
		message = {
			name = "Message",
			desc = "The message to send to chat when a spell is reflected.",
			type = "input",
			width = "double",
			get = function() return Plink.db.profile.message end,
			set = function(_, value) Plink.db.profile.message = value end
		},
		channel = {
			name = "Channel",
			desc = "The channel to send your message to.",
			type = "select",
			values = {"RAID", "PARTY", "Self", "None"},
			get = function()
					for k, v in pairs(chan) do
						if Plink.db.profile.channel == v then
							return k
						end
					end
				end,
			set = function(_, channel)
					Plink.db.profile.channel = chan[channel]
				end,
		},
		sound = {
			name = "Sound",
			desc = "The sound played when a spell is reflected.",
			type = "select",
			dialogControl = "LSM30_Sound",
			values = widgetLists.sound,
			get = function()
					return Plink.db.profile.sound
				end,
			set = function(_, sound)
					Plink.db.profile.sound = sound
				end
		},
	},
}

function Plink:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("PlinkDB", defaults, "Default")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Plink", options, {"plink", "pl"})
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Plink", "Plink")
end

function Plink:OnEnable()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function Plink:COMBAT_LOG_EVENT_UNFILTERED(event, _, eventType, _, _, _, _, destName, _, spellID)
	--IS THE ADDON IN STANDBY?--
	if not Plink.db.profile.standby then
		if eventType == "SPELL_AURA_APPLIED" and destName == player then
			--IS OUR AURA SPELL REFLECT?--
			if spellID == reflect then
				--START OUR ONUPDATE TIMER--
				timerFrame:Show()
				counter = 0
			end
		end
		if eventType == "SPELL_AURA_REMOVED" and destName == player then
			--DID WE LOSE THE SPELL REFLECT BUFF?--
			if spellID == reflect then
				--WAS IT ACTUALLY USED? OR DID IT WEAR OFF?--
				if counter < dur then
					PlaySoundFile(LSM:Fetch("sound", self.db.profile.sound))
					if self.db.profile.channel == "None" then return
					elseif self.db.profile.channel == "Self" then
						self:Print(self.db.profile.message)
					else
						SendChatMessage(self.db.profile.message, self.db.profile.channel)
					end
				end
				--TURN OFF ONUPDATE TIMER--
				timerFrame:Hide()
			end
		end
	end
end

--THE ACTUAL TIMER--
local function OnUpdate(self, elapsed)
	--MAKE THE COUNTER ACTUALLY COUNT--
	counter = counter + elapsed
end

timerFrame:SetScript("OnUpdate", OnUpdate)
timerFrame:Hide()
